##R2U2 Test Suite

####./Inputs/: folder contains atomic input traces

####./TL_formula/: folder contains TL formulas

####./results/: folder for regression test result

#  Set Up

### Dependencies:
- Python3's matplotlib and numpy packages.

### Build R2U2: 
- From the "r2u2_C_v1.0/" directory, run the command "make".

### Generate Formula, Input, and Oracle Files: 
- Navigate to the "test/" directory.
- Run the command "python3 TL_formula/genFormulas.py -m"
- Run the command "python3 Inputs/genInputs.py -m"
- Run the command "python3 Oracle/genOracle.py -m"

### Generate Plots of Inputs (Optional):
- Navigate to "test/" directory.
- Run the command "python3 Inputs/plotInputs.py -m"

### Run a Testing Subset: 
- In the "test/" directory, you may run one or more of the subset test files files (FT_PT_Subset.py, LargePtSubset.py, LargeFtSubset.py, FT_Subset.py) that compose our intial test suite.
- To run a subset of the test suite, run the command "python3 Subset/{subset_script} -v c" where subset_script is the name of the script being run.
- Output files will be found in the "test/results" directory

### Run a Report: 
- After running the subset through a subset test file, you can use a report script associated with that subset (FT_PT_Report.py, LargePtReport.py, LargeFtReport.py,FT_Report.py) to automatically check for differences between R2U2's result file and the Oracle file. 
	- For reference, an Oracle file is what we determined to be the ground truth for the given test formula and input. If you believe our Oracle file is incorrect, please contact us so we may investigate this discrepency.
- To run the report script for your particular subset file, run the command "python3 Report/{report_script}", where report_script is the name of the script being run.
	- Ultimately, this report script runs a "diff" process against R2U2's output files and the Oracle files. If there are differences, they will print to the terminal. You may also view an output file in the "test/" directory.
    - Note that you should remove previous test results before running another subset of a test. To do this, use the command "python3 Subset/{subset_script} -r a"

# Questions

### How do I remove generated files?
- Generated files can be removed by adding a "-r" tag to the end of a command that takes an argument. For example, running the command "python3 genInputs.py -r" will remove the previously generated input files. This also works for subset scripts. For example, the command "python3 FT_Subset.py -r c" will remove all files and directories in the "test/"results directory.
### What is a *.ftasm file? 
- This is an input file that allows R2U2 to be reconfigured without recompiling. It should be generated automatically by the prep script. If it is not present, the expected input file is probably not present, or the script is looking in the wrong place for the file.
### What is a ftscq.bin file?
- This file configures some of the memory needed for future-time temporal logic specs. This file is automatically generated by the prep script. It may be missing if the *.mltl formula file does not contain any future-time specifications.
